//Source file: C:\\source\\com\\hanbit\\comm\\code\\MetaCodeManager.java

package com.hanbit.comm.code;

import javax.jndi.*;

public class MetaCodeManager 
{
	
	/**
	Unique Instance. ϳ Instance 簡ϴ.
	 */
	private static MetaCodeManager _instance;
	public CodeManager codeManagers[];
	
	private MetaCodeManager() 
	{
        codeManagers = new CodeManager[2];
        
        CodeManager     deptMgr = new CodeManager("dept","pk_code.sp_getDeptCode");
        CodeManager     ctryMgr = new CodeManager("ctry","pk_code.sp_getCtryCode");
        
        codeManagers[0] = deptMgr;
        codeManagers[1] = ctryMgr;
        initAll();		
	}
	
	public void initAll() 
	{
        for(int i=0;i < codeManagers.length;i++){
            init(codeManagers[i]);
        }		
	}
	
	/**
	Instance   ִ  .
	
	@return com.hanbit.comm.code.MetaCodeManager
	 */
	public static MetaCodeManager getInstance() 
	{
        if(_instance == null) _instance = new MetaCodeManager();
        return _instance;		
	}
	
	/**
	@param mgr
	 */
	public void init(CodeManager mgr) 
	{
        try{
            Context ctx = new InitialContext();

            QuerySBHome home =(QuerySBHome)ctx.lookup("QuerySB");
            QuerySB sb = home.create();

            Parameter para = new Parameter();
            para.setVOClass(new Code());
            para.setStoredProcedure(mgr.getSpName());

            Vector vt = sb.select(para);
            if(vt != null){
                Object[] objects = vt.toArray();
                Code[]   codes   = new Code[objects.length];
                for(int i=0;i < objects.length;i++){
                    codes[i] = (Code)objects[i];
                }
                mgr.setCodes(codes);
            }
        }catch(Exception e){
            e.printStackTrace();
        }		
	}
	
	/**
	@return com.hanbit.comm.code.CodeManager[]
	 */
	public CodeManager[] getCodeManagers() 
	{
        return codeManagers;		
	}
	
	/**
	@param tableName
	@return com.hanbit.comm.code.CodeManager
	 */
	public CodeManager getCodeManager(String tableName) 
	{
        if(codeManagers == null) return null;
        for(int i=0;i < codeManagers.length;i++){
            if(codeManagers[i].getTableName().equals(tableName)){
                return codeManagers[i];
            }
        }
        return null;		
	}
}
