package com.hanbit.comm.cron;

import java.util.*;
import java.text.SimpleDateFormat;
import com.hanbit.comm.*;
import weblogic.time.common.*;
/**
 * Cron  ð ۾ ϴ cron ֻ ü̴.
 * <ul>
 * <li>      : Cron۾ Ѵ.
 * </ul>
 */
public abstract class Cron implements Schedulable,Triggerable {
    private boolean firstCall = true;
    private long    nextTime;
    private long    latestTime;
    private String  status = "Init";
    /**
     * ۾ ð Ѵ.
     */
    protected Crontab crontab = null;
    /**
     *  ۾ ۾ ޼ Ѵ.
     */
    protected StringBuffer messageBuf = new StringBuffer();
    
    /**
     *  ۾ Ѵ.
     * @return ð.
     */
    public final long schedule(long t){
        //crontabκ ۾ ð ؿ´.
        nextTime = crontab.getNext().getTime().getTime();
        // Ǵ ð  ֱ ð ȴ.
        latestTime = System.currentTimeMillis();
        //Clear Message
        clearMessage(messageBuf);
        
        status   = "On Processing";
        // ù° ȣ   ۾ .
        if(firstCall) firstCall = false;
        else job();
        
        // ð  ߸  α׷ Ѵ.
        if(nextTime < System.currentTimeMillis()){
            status = "Exit";
            return 0;
        }
        status = "Wait";
        return nextTime;
    }
    /**
     * schedule Ǹ triggeringǴ ۾ Ѵ.
     */
    public final void trigger(Schedulable sched){
    }
    
    /**
     * Cron۾ ޼ Ѵ.
     */
    public final void addMessage(String msg){
        messageBuf.append(msg+"\n");
    }
    
    /**
     * ۾޼ ´.
     */
    public final String getMessage(){
        return this.messageBuf.toString();
    }
    
    /**
     *  ¸ ش.
     */
    public final String getStatus(){
        return status;
    }
    
    /**
     * ¸ Ѵ.
     */
    public final void setStatus(String status){
        this.status = status;
    }
    
    /**
     *   ð ڰ    ٲ ش.
     */
    public final String getNextTime(){
        return getDateString(nextTime,"yyyy/MM/dd HH:mm:ss");
    }
    
    /**
     * ֱ  ð ڰ    ٲ ش.
     */
    public final String getLatestTime(){
        return getDateString(latestTime,"yyyy/MM/dd HH:mm:ss");
    }
    
    private String getDateString(long date,String format){
        SimpleDateFormat formatter = new SimpleDateFormat (format,Locale.KOREA);
        return formatter.format(new Date(date));
    }
    
    /**
     *   ۾.
     *  ༮ ̸ ݵ ־ Ѵ.
     */
    public abstract void job();
    
    /**
     * Clear Message Buffer
     */
    private void clearMessage(StringBuffer buf){
        if(buf == null) buf = new StringBuffer();
        if(buf.length() == 0) return;
        buf.delete(0,buf.length());
    }
}
