package com.hanbit.comm.cron;

import java.util.*;
import weblogic.common.*;
import weblogic.time.common.*;

public class CronManager {
    /**
     * Unique Instance. ϳ Instance 簡ϴ.
     */
    private static CronManager _instance;
    
    /**
     * Cron ClassName - Object Ѵ.
     */
    public HashMap cronMap = new HashMap();
    /**
     * Cron Scheduler ϸ ̰ cancel۾ Ѵ.
     */
    public HashMap jobMap  = new HashMap();
    
    /**
     * Private Empty Creator
     */
    private CronManager(){
    }
    
    /**
     * Instance   ִ  .
     */
    public static CronManager getInstance(){
        if(_instance == null) _instance = new CronManager();
        return _instance;
    }
    /**
     * Cron Manager Ѵ.
     */
    public void addJob(String className,T3ServicesDef t3s){
        ScheduledTriggerDef std = null;
        try{
            Cron cron = (Cron)Class.forName(className).newInstance();
            std = t3s.time().getScheduledTrigger(new Scheduler(cron),
                                                 new Trigger(className));
            std.setDaemon(true);
            std.schedule();
            //Register Job
            cronMap.put(className,cron);
            jobMap.put(className,std);
        }catch(Exception e){
            System.out.println("CronManager addJob:"+e.getMessage());
        }
    }
    
    /**
     * Cron Ѵ.
     */
    public void cancelJob(String className){
        ScheduledTriggerDef std = (ScheduledTriggerDef)jobMap.get(className);
        if(std == null) System.out.println(className+": Job Cancel Error: No Such A Job");
        else{
            try{
                std.cancel();
            }catch(Exception e){
                System.out.println(className+": Job Cancel Error: "+e.getMessage());
            }
            jobMap.remove(std);
        }
    }
    
    /**
     * ϵ  Cron Ѵ.
     */
    public void cancelAll(){
        if(jobMap == null) return;
        Iterator it = jobMap.keySet().iterator();
        while(it.hasNext()){
            String className = (String)it.next();
            cancelJob(className);
        }
    }
    
    /**
     * ʱȭ Ѵ.
     */
    public void init(){
        cancelAll();
        jobMap.clear();
        cronMap.clear();
    }
}
