package com.hanbit.comm.cron;

import java.util.*;

public final class Crontab{
    private Calendar prev = null;
    private String second     = "*";
    private String minute     = "*";
    private String hour       = "*";
    private String dayOfMonth = "*";
    private String month      = "*";
    private String dayOfWeek  = "*";
    
    private int field;
/**
 * Crontab н Crontabó ð Ѵ.
 * <ul>
 * <li>      : ۾ð Ѵ.
 * </ul>
 * <ul> Example
 * <li> Crontab("0","*","*","*","*","*") -- ź 00 
 * <li> Crontab("0","0","*","*","*","*") -- Ž 00 00 
 * <li> Crontab("0","0","0","*","*","*") --  00 00 00 
 * <li> Crontab("0","0","0","1","*","*") -- ſ 1 00 00 00 
 * <li> Crontab("0","0","0","31","*","*") -- ſ 31 00 00 00 (31    )
 * <li> Crontab("0","0","0","*","*","1") --  Ͽ 00 00 00 
 * </ul>
 * @param second     :  (0 ~ 59)
 * @param minute     :  (0 ~ 59)
 * @param hour       :  (0 ~ 23)
 * @param dayOfMonth :  (1 ~ 31)
 * @param month      :  (0 ~ 12)
 * @param dayOfWeek  :  (1 ~ 6) 1:Ͽ
 */
    public Crontab(String second,String minute,String hour,String dayOfMonth,String month,String dayOfWeek){
        this.second = second;
        this.minute = minute;
        this.hour = hour;
        this.dayOfMonth = dayOfMonth;
        this.month = month;
        this.dayOfWeek = dayOfWeek;
        prev = Calendar.getInstance();
    }
/**
 *  ɽð ´.
 */
    public Calendar getNext(){
        Calendar cal =  getNextTime(prev);
        prev = cal;
        prev.add(field,1);
        return cal;
    }

    private Calendar getNextTime(Calendar base){
        int s = Integer.parseInt(this.second);
        base.set(Calendar.SECOND,s);
        if(minute.equals("*")){
            field = Calendar.MINUTE;
        }else{
            int min = Integer.parseInt(this.minute);
            base.set(Calendar.MINUTE,min);
            if(hour.equals("*")){
                field = Calendar.HOUR_OF_DAY;
            }else{
                int h = Integer.parseInt(hour);
                base.set(Calendar.HOUR_OF_DAY,h);
                if(dayOfWeek.equals("*")){
                    if(dayOfMonth.equals("*")){
                        field = Calendar.DAY_OF_MONTH;
                    }else{
                        int d = Integer.parseInt(dayOfMonth);
                        if(d > base.getActualMaximum(Calendar.DAY_OF_MONTH)) d = base.getActualMaximum(Calendar.DAY_OF_MONTH);
                        base.set(Calendar.DAY_OF_MONTH,d);
                        if(month.equals("*")){
                            field = Calendar.MONTH;
                        }else{
                            int m = Integer.parseInt(month);
                            base.set(Calendar.MONTH,m);
                        }
                    }
                }else{  
                    field = Calendar.WEEK_OF_MONTH;
                    int dw = Integer.parseInt(dayOfWeek);
                    base.set(Calendar.DAY_OF_WEEK,dw);
                }
            }
        }
        return base;
    }
}
