package com.hanbit.comm.ejb.session;

import com.hanbit.comm.valueobject.*;

import com.hanbit.comm.util.*;

import java.rmi.RemoteException;

import java.sql.*;

import java.util.Vector;

import javax.ejb.*;

import javax.naming.*;

import oracle.jdbc.driver.*;


public class QuerySBBean extends HanbitSessionBean {
    public Vector select(Parameter para) throws ConnectException, SQLException, 
                                                ValueObjectCreateException, 
                                                RemoteException {
        Vector vt = null;
        Connection conn = null;
        CallableStatement cstmt = null;
        ResultSet rset = null;

        try {
            conn = HanbitConnection.getConnection();

            int size = para.getArgumentsSize();
            cstmt = conn.prepareCall("begin " + para.getStoredProcedure() + 
                                          "(" + makeQuestion(size) + "); end;");

            int i = 1;

            while (para.hasMoreElements()) {
                cstmt.setString(i++, (String) para.nextElement());
            }

            cstmt.registerOutParameter(i,OracleTypes.CURSOR);

            cstmt.execute();
            rset = (ResultSet)cstmt.getObject (i);

            if(rset == null) throw new ValueObjectCreateException("Rset is NULL");

			ValueObjectCreator creator   = new ValueObjectCreator();
            ValueObjectFactoryByResultSet factory = new ValueObjectFactoryByResultSet(rset,para.getVOClass());

            vt = creator.getValueObjectList(factory);
        } finally {
            HanbitConnection.close(conn, rset, cstmt);
        }

        return vt;
    }

    private String makeQuestion(int size) {
        StringBuffer question = new StringBuffer();

        for (int i = 1; i <= size; i++) {
            question.append("?,");
        }

        question.append("?"); //For Return Value

        return question.toString();
    }
}
