package com.hanbit.comm.servlet;
import java.io.*;
import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;

import com.hanbit.comm.performance.*;

/**
 * Servlet Hanbit ֻ Servlet̸ HttpServlet ӹ޴´.
 * <ul>
 * <li>      : Http Request  ⺻ 񽺸 Ѵ.
 *                 Java Server Page Ѵ.
 * </ul>
 *
 */

public class HanbitServlet extends HttpServlet {
    // command jsp  Ʈ Ѵ.
    protected HashMap commands;
    // Default Error 
    private String error = "/error.jsp";
    
    /**
     * νƮȭɶ  ѹ ȣȴ.⼭ ӹ  Ŭ 
     * <code>postInit(config)</code> Ѵ.
     * @param config ServletConfig
     * @exception ServletException
     */
    public void init(ServletConfig config) throws ServletException{
        super.init(config);
        postInit(config);
    }
    
    /**
     * ThreadǾ Ǿ κ̴. ԵǾ  κе Jsp
     * Ͽ Եȴ.
     */
    public void service(HttpServletRequest req,HttpServletResponse res)
    throws ServletException,IOException {
        RequestDispatcher rd;
        String next;
        
        try{
            Command cmd = lookupCommand(req.getParameter("cmd"));
            
            //cmd  = new AuthorizationFilter(new PerformanceFilter(cmd));
            cmd  = new PerformanceFilter(cmd);
            next = cmd.execute(req);
            preDispating(req,res);
        } catch(Exception e){
             req.setAttribute("javax.servlet.jsp.jspException",e);
             next = "/error.jsp";
        }
        rd = getServletContext().getRequestDispatcher(next);
        rd.forward(req,res);
    }
    
    /**
     * ڷ  Ѿ Ķ cmd ε Command ü 
     * HashTable ã ̸ Ѱش.
     */
    private Command lookupCommand(String cmd)
    throws CommandException{
        if((cmd == null) || (cmd.trim().length() == 0))
            cmd = "main";
        if(commands.containsKey(cmd)){
            return (Command)commands.get(cmd);
        }else{
            throw new CommandException("Invalid Command Identifier : "+cmd);
        }
    }
    /**
     * Command cmd  Ͽ Ѵ.
     * @param config Servletconfig
     */
    public void postInit(ServletConfig config){
    }
    /**
     * Request Dispatchingϱ   κ ۼѴ.
     * @param req HttpServletRequest
     * @param res HttpServletResponse
     */
    public void preDispating(HttpServletRequest req,HttpServletResponse res){
    }
}
