package com.hanbit.comm.util;

import java.text.*;
import java.util.*; 
import java.sql.*;

/**
* <ul>
* <li>          : ¥ ð   
* </ul>
*/
public final class DateUtil {

    /**
     * ڸ ⺻ "yyyy/MM/dd" ˻Ѵ
     * @param s üũϰϴ ¥ Ʈ("yyyy/MM/dd" _
     * @return boolean true ¥  °, ϴ ¥ 
     *                 false ¥   ʰų,  ʴ ¥ 
     */
    public static boolean isValid(String s) throws Exception {
        return isValid(s, "yyyy/MM/dd");
    }

    /**
     * ڸ ڰ  Ŀ  üũѴ
     * @param s üũϰϴ date String
     * @param format üũϰ ϴ  ( : "yyyy-MM-dd")
     * @return boolean true ¥  °, ϴ ¥ 
     *                 false ¥   ʰų,  ʴ ¥ 
     */
    public static boolean isValid(String s, String format) {
        java.text.SimpleDateFormat formatter = 
            new java.text.SimpleDateFormat (format, java.util.Locale.KOREA);
        java.util.Date date = null;
        try {
            date = formatter.parse(s);
        }
        catch(java.text.ParseException e) {
            return false;
        }
        
        if ( ! formatter.format(date).equals(s) )
            return false;

        return true;
    }

    /**
     * @return ڸ "yyyy/MM/dd"  return Ѵ.
     */
    public static String getTodayString() {
        return getTodayString("yyyy/MM/dd");
    }

    public static String getTodayString(String pattern) {
        Timestamp today = new Timestamp(System.currentTimeMillis());
        return makeDateFormat(today,pattern);
    }
    
    public static Timestamp getToday(){
        return new java.sql.Timestamp(System.currentTimeMillis());
    }

    public static java.sql.Timestamp makeTimestamp(String str,String format)
    throws ParseException
    {
        if(str == null || str.equals(""))  return null;
        java.sql.Timestamp t = null;
        SimpleDateFormat formatter = new SimpleDateFormat(format);
        java.util.Date date = formatter.parse(str);
        t = new java.sql.Timestamp(date.getTime());
        return t;
    }
    public static java.sql.Timestamp makeTimestamp(String str)
    throws ParseException
    {    
        if(str == null || str.equals(""))  return null;
        java.sql.Timestamp time = null;
        time = makeTimestamp(str,"yyyy/MM/dd");
        return time;
    }
    
      public static String makeDateFormat(java.sql.Timestamp t,String format) {
          if(t == null) return "";
        java.text.SimpleDateFormat formatter = new java.text.SimpleDateFormat (format, java.util.Locale.KOREA);
        return formatter.format(t);
    }

      public static String makeDateFormat(java.sql.Timestamp t) {
          return makeDateFormat(t,"yyyy/MM/dd");
    }
 }
