//Source file: C:\\source\\com\\hanbit\\comm\\valueobject\\RowFactoryByResultSet.java
package com.hanbit.comm.valueobject;

import java.sql.*;

import com.hanbit.comm.ejb.session.Parameter;
import oracle.jdbc.driver.*;
import com.hanbit.comm.util.*;

public class RowFactoryByResultSet extends ValueObjectFactory {
    Connection conn;
    ResultSet  rset;
    Row row = new Row();
    String[] title;

    public RowFactoryByResultSet(Parameter para) throws ValueObjectCreateException{
        CallableStatement cstmt = null;

        try {
            conn = HanbitConnection.getConnection();

            int size = para.getArgumentsSize();
            cstmt = conn.prepareCall("begin " + para.getStoredProcedure() + 
                                          "(" + makeQuestion(size) + "); end;");

            int i = 1;

            while (para.hasMoreElements()) {
                cstmt.setString(i++, (String) para.nextElement());
            }

            cstmt.registerOutParameter(i,OracleTypes.CURSOR);

            cstmt.execute();
            rset = (ResultSet)cstmt.getObject (i);

            if(rset == null) throw new ValueObjectCreateException("Rset is NULL");
            source = rset;
            
            ResultSetMetaData metaData = rset.getMetaData();
            int colCount = metaData.getColumnCount();
            title = new String[colCount];
            for (int j = 0; j < colCount; j++) {
                title[j] = metaData.getColumnName(j + 1);
            }
        } catch (Exception e) {
            e.printStackTrace();
            try{
                conn.close();
            }catch(Exception ee){
                ee.printStackTrace();
            }
        }
    }

    public boolean hasMoreElements() {
        if (source == null) {
            return false;
        }

        ResultSet rset = (ResultSet) source;

        try {
            if (rset.next()) {
                return true;
            } else {
                conn.close();
            }
        } catch (Exception e) {
            e.printStackTrace();
            try{
                conn.close();
            }catch(Exception ee){}
            return false;
        }

        return false;
    }

    public Object nextElement() {
        ResultSet rset = (ResultSet) source;
        row.clear();

        if(title == null) return null;

        try {
            for (int i = 0; i < title.length; i++) {
                row.put(title[i], rset.getString(title[i]));
            }
        } catch (SQLException se) {
            se.printStackTrace();
            return null;
        }

        return row;
    }

    private String makeQuestion(int size) {
        StringBuffer question = new StringBuffer();

        for (int i = 1; i <= size; i++) {
            question.append("?,");
        }

        question.append("?"); //For Return Value

        return question.toString();
    }
}
