package com.hanbit.ga.ga1101;

import com.hanbit.comm.ejb.entity.*;
import com.hanbit.comm.servlet.*;
import com.hanbit.comm.valueobject.*;
import com.hanbit.ga.ejb.entity.emp.*;
import com.hanbit.ga.ejb.session.emp.*;

import javax.ejb.*;
import javax.naming.*;

import javax.servlet.*;
import javax.servlet.http.*;

import java.util.*;
import java.rmi.RemoteException;

public class GA1101DML implements Command{
    private String next;

    public GA1101DML(String next){
        this.next = next;
    }
    
    public String execute(HttpServletRequest req)
    throws CommandException{
        HttpSession session = req.getSession();
        String msgKey       = req.getRequestedSessionId();
        String cmd  = req.getParameter("cmd");

        try{
            //ValueObject Object
            Vector empVt      = (Vector)session.getAttribute(GA1101Servlet.VT_NAME);
            ValueObjectFactoryByPage factory = new ValueObjectFactoryByPage(req,new EmpVO());
            
            EmpVO pageVO      = (EmpVO)factory.nextElement();
            EmpVO  empVO;;
            
            //Transaction Object
            Context ctx = new InitialContext();
            EmpSBHome home =(EmpSBHome)ctx.lookup("EmpSB");
            EmpSB empSB = home.create();

            if(cmd.equals("insert")){
                if(empVt == null){
                    empVt = new Vector();
                    session.setAttribute(GA1101Servlet.VT_NAME,empVt);
                }
                empVO = empSB.employ(pageVO);
                empVt.add(empVO);
                req.setAttribute(GA1101Servlet.DM_NAME,empVO);
                req.setAttribute(msgKey,new Message("Successfully Inserted"));
                return next;
            } else if(cmd.equals("delete")){
                if(empVt != null){
                    int   idx  = findInVector(empVt,pageVO);
                    empVO      = (EmpVO)empVt.get(idx);
                    empSB.retire(empVO);
                    empVt.removeElementAt(idx);
                    req.setAttribute(msgKey,new Message("Successfully Deleted"));
                }
            } else if(cmd.equals("update")){
                if(empVt != null){
                    int   idx  = findInVector(empVt,pageVO);
                    empVO      = (EmpVO)empVt.get(idx);
                    pageVO.setUpddate(empVO.getUpddate());
                    empVO = empSB.update(pageVO);
                    empVt.set(idx,empVO);
                    req.setAttribute(GA1101Servlet.DM_NAME,empVO);
                    req.setAttribute(msgKey,new Message("Successfully Updated"));
                }
            }
        }catch(DuplicateKeyException e){
            req.setAttribute(msgKey,new Message("Already Exist!"));
            return GA1101Servlet.dir+"msg.jsp";
        }catch(FinderException e){
            req.setAttribute(msgKey,new Message("Already Deleted.Please Requery!"));
            return GA1101Servlet.dir+"msg.jsp";
        }catch(SnapShotTooOldException e){
            req.setAttribute(msgKey,new Message("Already Updated.Please Requery!"));
            return GA1101Servlet.dir+"msg.jsp";
        }catch(Exception e){
            throw new CommandException(e);
        }
        return next;
    }
    
    private int findInVector(Vector empVT,EmpVO pageVO){
        if(empVT == null) return -1;
        if(pageVO == null) return -1;
        
        for(int i=0;i < empVT.size();i++){
            EmpVO empVO = (EmpVO)empVT.get(i);
            if(empVO.getEmpno() == pageVO.getEmpno()) return i;
        }
        return -1;
    }
}
