CREATE OR REPLACE PACKAGE BODY pk_News
AS
-- PostInfo Է¹޾ NewsRef(Cursor) ϴ Procedure
   PROCEDURE sp_GetNewsByPostInfo(pvc_poster          IN     News.POSTER%TYPE,
                                  ResultSet           IN OUT NewsRef)
  IS
  BEGIN
    OPEN ResultSet FOR
    SELECT
           a.poster                                    poster,
           a.postdate                                  postdate,
           a.postterm                                  postterm,
           a.postdate + a.postterm/1440                expiredate,
           a.head                                      head,
           a.msg                                       msg,
           a.linkpage                                  linkpage,
           a.upddate                                   upddate
      FROM news a
     WHERE a.poster like pvc_poster||'%'
     ORDER BY 1,2;
   EXCEPTION 
        WHEN NO_DATA_FOUND THEN
             NULL;
  END sp_GetNewsByPostInfo;
-- ѿθ Է¹޾ NewsRef(Cursor) ϴ Procedure
   PROCEDURE sp_GetTodayNews(ResultSet           IN OUT NewsRef)
  IS
  BEGIN
    OPEN ResultSet FOR
    SELECT
           a.poster                                    poster,
           a.postdate                                  postdate,
           a.postterm                                  postterm,
           a.postdate + a.postterm/1440                expiredate,
           a.head                                      head,
           a.msg                                       msg,
           a.linkpage                                  linkpage,
           a.upddate                                   upddate
      FROM news a
     WHERE postdate + (a.postterm/1440) > sysdate
     ORDER BY 2,1;
   EXCEPTION 
        WHEN NO_DATA_FOUND THEN
             NULL;
  END sp_GetTodayNews;
-- Expired News
  PROCEDURE sp_GetExpiredNews(ResultSet           IN OUT NewsRef)
  IS
  BEGIN
    OPEN ResultSet FOR
    SELECT
           a.poster                                    poster,
           a.postdate                                  postdate,
           a.postterm                                  postterm,
           a.postdate + a.postterm/1440                expiredate,
           a.head                                      head,
           a.msg                                       msg,
           a.linkpage                                  linkpage,
           a.upddate                                   upddate
      FROM news a
     WHERE postdate + (a.postterm/1440) < sysdate
     ORDER BY 2,1;
   EXCEPTION 
        WHEN NO_DATA_FOUND THEN
             NULL;
  END sp_GetExpiredNews;
END pk_News;
/
show error 
clear
