CREATE OR REPLACE PACKAGE BODY pk_Stock
AS
   -- Get Today Stock Price
  PROCEDURE sp_GetTodayStockByCmpy(pvc_cmpyCode        IN     Stock.CMPYCODE%TYPE,
                                   ResultSet           IN OUT StockRef)
  IS
  BEGIN
    OPEN ResultSet FOR
    SELECT
           a.cmpycode                                     cmpycode,
           a.stockdate                                    stockdate,
           a.price                                        price,
           a.upddate                                      upddate
      FROM stock a
     WHERE a.cmpycode = pvc_cmpyCode
       AND to_char(a.stockdate,'yyyy/mm/dd') = to_char(sysdate,'yyyy/mm/dd')
     ORDER BY 1,2;
   EXCEPTION 
        WHEN NO_DATA_FOUND THEN
             NULL;
  END sp_GetTodayStockByCmpy;
END pk_Stock;
/
show error 
clear
